package jimenezcarlos.android.uoc.edu.camina;


import android.net.Uri;
import android.os.Bundle;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.viewpager.widget.ViewPager;

import com.google.android.material.tabs.TabLayout;

import jimenezcarlos.android.uoc.edu.menu.LateralMenu;
import jimenezcarlos.android.uoc.edu.util.ClassificationPageAdapter;

// This class must implement the Fragment.OnFragmentInteractionListener of every fragment included
public class ClassificationActivity extends AppCompatActivity implements ClassificationFragment.OnFragmentInteractionListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Load de layout
        setContentView(R.layout.activity_classification);
        //Get toolbar from the layout and set it
        Toolbar toolbar = findViewById(R.id.cl_toolbar);
        setSupportActionBar(toolbar);

        //Include the Lateral Menu
        LateralMenu.getDrawer(this,savedInstanceState, toolbar,6);

        TabLayout tabLayout = findViewById(R.id.tabLayout);
        ViewPager viewPager = findViewById(R.id.cl_viewPager);
        //Create new ClassificationPageAdapter (extends FragmentPagerAdapter), with parameters FragmentManager and the number of tabs included
        ClassificationPageAdapter classificationPageAdapter = new ClassificationPageAdapter(getSupportFragmentManager(), tabLayout.getTabCount());
        //Set the adapter
        viewPager.setAdapter(classificationPageAdapter);
        //Add an listener to react to page change (the corresponding fragment will be shown when swapping)
        viewPager.addOnPageChangeListener(new TabLayout.TabLayoutOnPageChangeListener(tabLayout));
        //And add another listener to react when a tab is selected
        tabLayout.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                // Set the appropriate item (fragment) when its corresponding tab is selected
                viewPager.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {
            }
        });

    }

    @Override
    public void onFragmentInteraction(Uri uri){
        //We leave it empty, since we don't need it
    }





















}






