package jimenezcarlos.android.uoc.edu.menu;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.widget.Toolbar;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import com.firebase.ui.auth.AuthUI;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.mikepenz.google_material_typeface_library.GoogleMaterial;
import com.mikepenz.itemanimators.AlphaCrossFadeAnimator;
import com.mikepenz.materialdrawer.AccountHeader;
import com.mikepenz.materialdrawer.AccountHeaderBuilder;
import com.mikepenz.materialdrawer.Drawer;
import com.mikepenz.materialdrawer.DrawerBuilder;
import com.mikepenz.materialdrawer.model.DividerDrawerItem;
import com.mikepenz.materialdrawer.model.PrimaryDrawerItem;
import com.mikepenz.materialdrawer.model.ProfileDrawerItem;
import com.mikepenz.materialdrawer.model.ProfileSettingDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IProfile;
import com.mikepenz.materialdrawer.util.AbstractDrawerImageLoader;
import com.mikepenz.materialdrawer.util.DrawerImageLoader;
import com.squareup.picasso.Picasso;

import jimenezcarlos.android.uoc.edu.camina.AchievementsActivity;
import jimenezcarlos.android.uoc.edu.camina.CertifyItineraryActivity;
import jimenezcarlos.android.uoc.edu.camina.ClassificationActivity;
import jimenezcarlos.android.uoc.edu.camina.MapsActivity;
import jimenezcarlos.android.uoc.edu.camina.MetroMapActivity;
import jimenezcarlos.android.uoc.edu.camina.MetroStopSelectionActivity;
import jimenezcarlos.android.uoc.edu.camina.NewJourneyActivity;
import jimenezcarlos.android.uoc.edu.camina.R;
import jimenezcarlos.android.uoc.edu.camina.RouteSelectionActivity;
import jimenezcarlos.android.uoc.edu.camina.StartItineraryActivity;
import jimenezcarlos.android.uoc.edu.camina.StatisticsActivity;
import jimenezcarlos.android.uoc.edu.camina.UserIdentificationActivity;
import jimenezcarlos.android.uoc.edu.camina.UserProfileActivity;


public class LateralMenu {


    private static FirebaseUser user;
    private static final int CLOSE_SESSION = 100001;

    public static void getDrawer(final Activity activity, Bundle bundle, Toolbar toolbar, int identifier) {

        user = FirebaseAuth.getInstance().getCurrentUser();
        LocalBroadcastManager localBroadcastManager = LocalBroadcastManager.getInstance(activity);

        //initialize and create the image loader logic
        DrawerImageLoader.init(new AbstractDrawerImageLoader() {
            @Override
            public void set(ImageView imageView, Uri uri, Drawable placeholder) {


                Picasso.get()
                        .load(uri)
                        .resize(200, 200)
                        .centerCrop()
                        .placeholder(placeholder)
                        .error(R.drawable.man)
                        .into(imageView);


            }

            @Override
            public void cancel(ImageView imageView) {

                Picasso.get().cancelRequest(imageView);


            }
        });

        IProfile profile = new ProfileDrawerItem().withName(user.getDisplayName()).withEmail(user.getEmail()).withIcon(user.getPhotoUrl());

        AccountHeader headerResult = null;
        headerResult = new AccountHeaderBuilder()
                .withActivity(activity)
                .withTranslucentStatusBar(true)
                .withHeaderBackground(R.drawable.header_background)
                .addProfiles(
                        profile,
                        //Google uses 14dp for the add account icon in gmail but 20dp for the normal icons (like manage account)
                        new ProfileSettingDrawerItem().withName("Cerrar sesión").withIcon(GoogleMaterial.Icon.gmd_close).withIdentifier(CLOSE_SESSION)
                )
                .withOnAccountHeaderListener(new AccountHeader.OnAccountHeaderListener() {
                    @Override
                    public boolean onProfileChanged(View view, IProfile profile, boolean current) {
                        if (profile!=null) {
                            if (profile.getIdentifier()==CLOSE_SESSION) {

                                AuthUI.getInstance()
                                        .signOut(activity)
                                        .addOnCompleteListener(new OnCompleteListener<Void>() {
                                            public void onComplete(@NonNull Task<Void> task) {
                                                //Inform the user that sign out has been performed and go to UserIdentificationActivity
                                                AlertDialog alertDialog = new AlertDialog.Builder(activity).create();
                                                alertDialog.setTitle(activity.getString(R.string.sign_out_title));
                                                alertDialog.setMessage(activity.getString(R.string.sign_out_message));
                                                alertDialog.setButton(AlertDialog.BUTTON_NEUTRAL, "OK",
                                                        new DialogInterface.OnClickListener() {
                                                            public void onClick(DialogInterface dialog, int which) {
                                                                dialog.dismiss();
                                                                Intent intent = new Intent(activity, UserIdentificationActivity.class);
                                                                view.getContext().startActivity(intent);
                                                                activity.finish();
                                                            }
                                                        });

                                                alertDialog.show();
                                            }
                                        });

                                //FirebaseAuth.getInstance().signOut();




                            }



                        }

                        return false;
                    }
                })
                .withSavedInstance(bundle)
                .build();


        PrimaryDrawerItem item1 = new PrimaryDrawerItem().withIdentifier(1).withName(R.string.drawer_item_certify).withIcon(R.drawable.icono_certificar_trayecto_negro).withIdentifier(1).withSelectable(false);
        PrimaryDrawerItem item2 = new PrimaryDrawerItem().withIdentifier(2).withName(R.string.drawer_item_new_journey).withIcon(R.drawable.icono_nuevo_trayecto_negro).withIdentifier(2).withSelectable(false);
        PrimaryDrawerItem item3 = new PrimaryDrawerItem().withIdentifier(3).withName(R.string.drawer_item_map).withIcon(R.drawable.icono_mapa_negro).withIdentifier(3).withSelectable(false);
        PrimaryDrawerItem item4 = new PrimaryDrawerItem().withIdentifier(4).withName(R.string.drawer_item_statistics).withIcon(R.drawable.icono_estadisticas_negro).withIdentifier(4).withSelectable(false);
        PrimaryDrawerItem item5 = new PrimaryDrawerItem().withIdentifier(5).withName(R.string.drawer_item_achievements).withIcon(R.drawable.icono_logros_negro).withIdentifier(5).withSelectable(false);;
        PrimaryDrawerItem item6 = new PrimaryDrawerItem().withIdentifier(6).withName(R.string.drawer_item_classification).withIcon(R.drawable.icono_clasificacion_negro).withIdentifier(6).withSelectable(false);
        PrimaryDrawerItem item7 = new PrimaryDrawerItem().withIdentifier(7).withName(R.string.drawer_item_metro_map).withIcon(R.drawable.icono_plano_metro_negro).withIdentifier(7).withSelectable(false);
        PrimaryDrawerItem item8 = new PrimaryDrawerItem().withIdentifier(8).withName(R.string.drawer_item_profile).withIcon(R.drawable.icono_perfil_negro).withIdentifier(8).withSelectable(false);



        //create the drawer and remember the `Drawer` result object
        Drawer result = new DrawerBuilder()
                .withActivity(activity)
                .withSavedInstance(bundle)
                .withDisplayBelowStatusBar(false)
                .withToolbar(toolbar)
                .withTranslucentStatusBar(false)
                .withHasStableIds(true)
                .withItemAnimator(new AlphaCrossFadeAnimator())
                .withAccountHeader(headerResult) //set the AccountHeader we created earlier for the header
                .withActionBarDrawerToggle(true)
                .withSelectedItem(identifier)
                //.withDrawerLayout(R.layout.material_drawer_fits_not)
                .addDrawerItems(
                        item1,
                        item2,
                        item3,
                        item4,
                        item5,
                        item6,
                        new DividerDrawerItem(),
                        item7,
                        item8
                )
                .withOnDrawerItemClickListener(new Drawer.OnDrawerItemClickListener() {
                    @Override
                    public boolean onItemClick(View view, int position, IDrawerItem drawerItem) {
                        //check if the drawerItem is set.
                        //there are different reasons for the drawerItem to be null
                        //--> click on the header
                        //--> click on the footer
                        //those items don't contain a drawerItem

                        if (drawerItem != null) {


                            if (activity instanceof RouteSelectionActivity || activity instanceof MetroStopSelectionActivity
                                    || activity instanceof StartItineraryActivity) {

                                // Create intent with action
                                Intent localIntent = new Intent("finish-all-activities-over-me");
                                // Add the number identifying the activity to start
                                localIntent.putExtra("activity to start", position);
                                // Send local broadcast
                                localBroadcastManager.sendBroadcast(localIntent);

                            } else {

                                Intent intent = null;

                                if (drawerItem.getIdentifier() == 1 && !(activity instanceof CertifyItineraryActivity)) {
                                    intent = new Intent(activity, CertifyItineraryActivity.class);

                                } else if (drawerItem.getIdentifier() == 2 && !(activity instanceof NewJourneyActivity)) {

                                    intent = new Intent(activity, NewJourneyActivity.class);

                                } else if (drawerItem.getIdentifier() == 3 && !(activity instanceof MapsActivity)) {
                                    // If user wants to go to Map from any activity different to Map, just kill origin activity.
                                    // The behaviour of Camina is that Map is the "home" activity.

                                    activity.finish();

                                } else if (drawerItem.getIdentifier() == 4 && !(activity instanceof StatisticsActivity)) {
                                    intent = new Intent(activity, StatisticsActivity.class);

                                } else if (drawerItem.getIdentifier() == 5 && !(activity instanceof AchievementsActivity)) {
                                    intent = new Intent(activity, AchievementsActivity.class);

                                } else if (drawerItem.getIdentifier() == 6 && !(activity instanceof ClassificationActivity)) {
                                    intent = new Intent(activity, ClassificationActivity.class);

                                } else if (drawerItem.getIdentifier() == 7 && !(activity instanceof MetroMapActivity)) {
                                    intent = new Intent(activity, MetroMapActivity.class);

                                } else if (drawerItem.getIdentifier() == 8 && !(activity instanceof UserProfileActivity)) {
                                    intent = new Intent(activity, UserProfileActivity.class);

                                }
                                if (intent != null) {
                                    view.getContext().startActivity(intent);
                                    if (!(activity instanceof MapsActivity)) activity.finish();
                                }
                            }
                        }
                            return false;

                    }
                }).build();



    }




}








