package jimenezcarlos.android.uoc.edu.rest.adapter;
import com.google.gson.JsonObject;

import java.util.Map;

import jimenezcarlos.android.uoc.edu.rest.constants.ApiTMBConstants;
import jimenezcarlos.android.uoc.edu.rest.model.TMBTransitAPI.TMBTransitMetroLinesAPIResponse;
import jimenezcarlos.android.uoc.edu.rest.model.TMBTransitAPI.TMBTransitStationsInLineAPIResponse;
import jimenezcarlos.android.uoc.edu.rest.service.TMBService;
import retrofit2.Call;

public class TMBAdapter extends BaseAdapter implements TMBService {

    private TMBService mTMBService;

    public TMBAdapter() {
        super(ApiTMBConstants.BASE_TMB_URL);
        mTMBService = createService(TMBService.class);
    }

    // Method to get all Metro Lines (geometry), name, and colors, from TMB API
    @Override
    public Call<TMBTransitMetroLinesAPIResponse> getAllMetroStations () {
        return mTMBService.getAllMetroStations();
    }
    // Method to get all metro stations in a given line, from TMB API
    @Override
    public Call<TMBTransitStationsInLineAPIResponse> getMetroLineStations (String mTMBLine_code) {
        return mTMBService.getMetroLineStations(mTMBLine_code);
    }

    @Override
    public Call<JsonObject> getPlannedRoute (Map<String, String> mTMBPlannerQuery) {
        return mTMBService.getPlannedRoute(mTMBPlannerQuery);
    }




}
