
package jimenezcarlos.android.uoc.edu.rest.model.TMBPlannerAPI;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

public class Leg implements Serializable {

    @SerializedName("startTime")
    @Expose
    private String startTime;
    @SerializedName("endTime")
    @Expose
    private String endTime;
    @SerializedName("departureDelay")
    @Expose
    private Integer departureDelay;
    @SerializedName("arrivalDelay")
    @Expose
    private Integer arrivalDelay;
    @SerializedName("realTime")
    @Expose
    private Boolean realTime;
    @SerializedName("distance")
    @Expose
    private Double distance;
    @SerializedName("pathway")
    @Expose
    private Boolean pathway;
    @SerializedName("mode")
    @Expose
    private String mode;
    @SerializedName("route")
    @Expose
    private String route;
    @SerializedName("agencyTimeZoneOffset")
    @Expose
    private Integer agencyTimeZoneOffset;
    @SerializedName("interlineWithPreviousLeg")
    @Expose
    private Boolean interlineWithPreviousLeg;
    @SerializedName("from")
    @Expose
    private TransitStop from;
    @SerializedName("to")
    @Expose
    private TransitStop to;
    @SerializedName("legGeometry")
    @Expose
    private LegGeometry legGeometry;
    @SerializedName("rentedBike")
    @Expose
    private Boolean rentedBike;
    @SerializedName("duration")
    @Expose
    private Integer duration;
    @SerializedName("transitLeg")
    @Expose
    // Indicates whether this sub-route is on foot or not
    private Boolean transitLeg;
    @SerializedName("intermediateStops")
    @Expose
    private List<TransitStop> intermediateStops = null;
    @SerializedName("steps")
    @Expose
    private List<Step> steps = null;
    @SerializedName("agencyName")
    @Expose
    private String agencyName;
    @SerializedName("agencyUrl")
    @Expose
    private String agencyUrl;
    @SerializedName("routeColor")
    @Expose
    private String routeColor;
    @SerializedName("routeType")
    @Expose
    private Integer routeType;
    @SerializedName("routeId")
    @Expose
    private String routeId;
    @SerializedName("routeTextColor")
    @Expose
    private String routeTextColor;
    @SerializedName("headsign")
    @Expose
    private String headsign;
    @SerializedName("agencyId")
    @Expose
    private String agencyId;
    @SerializedName("tripId")
    @Expose
    private String tripId;
    @SerializedName("serviceDate")
    @Expose
    private String serviceDate;
    @SerializedName("routeShortName")
    @Expose
    private String routeShortName;
    @SerializedName("routeLongName")
    @Expose
    private String routeLongName;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Leg() {
    }

    /**
     * 
     * @param legGeometry
     * @param routeColor
     * @param transitLeg
     * @param routeTextColor
     * @param distance
     * @param serviceDate
     * @param agencyId
     * @param tripId
     * @param departureDelay
     * @param routeLongName
     * @param mode
     * @param duration
     * @param headsign
     * @param routeId
     * @param agencyUrl
     * @param startTime
     * @param from
     * @param rentedBike
     * @param routeType
     * @param arrivalDelay
     * @param agencyTimeZoneOffset
     * @param steps
     * @param agencyName
     * @param realTime
     * @param routeShortName
     * @param route
     * @param pathway
     * @param endTime
     * @param to
     * @param intermediateStops
     * @param interlineWithPreviousLeg
     */
    public Leg(String startTime, String endTime, Integer departureDelay, Integer arrivalDelay, Boolean realTime, Double distance, Boolean pathway, String mode, String route, Integer agencyTimeZoneOffset, Boolean interlineWithPreviousLeg, TransitStop from, TransitStop to, LegGeometry legGeometry, Boolean rentedBike, Integer duration, Boolean transitLeg, List<TransitStop> intermediateStops, List<Step> steps, String agencyName, String agencyUrl, String routeColor, Integer routeType, String routeId, String routeTextColor, String headsign, String agencyId, String tripId, String serviceDate, String routeShortName, String routeLongName) {
        super();
        this.startTime = startTime;
        this.endTime = endTime;
        this.departureDelay = departureDelay;
        this.arrivalDelay = arrivalDelay;
        this.realTime = realTime;
        this.distance = distance;
        this.pathway = pathway;
        this.mode = mode;
        this.route = route;
        this.agencyTimeZoneOffset = agencyTimeZoneOffset;
        this.interlineWithPreviousLeg = interlineWithPreviousLeg;
        this.from = from;
        this.to = to;
        this.legGeometry = legGeometry;
        this.rentedBike = rentedBike;
        this.duration = duration;
        this.transitLeg = transitLeg;
        this.intermediateStops = intermediateStops;
        this.steps = steps;
        this.agencyName = agencyName;
        this.agencyUrl = agencyUrl;
        this.routeColor = routeColor;
        this.routeType = routeType;
        this.routeId = routeId;
        this.routeTextColor = routeTextColor;
        this.headsign = headsign;
        this.agencyId = agencyId;
        this.tripId = tripId;
        this.serviceDate = serviceDate;
        this.routeShortName = routeShortName;
        this.routeLongName = routeLongName;
    }

    public String getStartTime() {
        return startTime;
    }

    public void setStartTime(String startTime) {
        this.startTime = startTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public Integer getDepartureDelay() {
        return departureDelay;
    }

    public void setDepartureDelay(Integer departureDelay) {
        this.departureDelay = departureDelay;
    }

    public Integer getArrivalDelay() {
        return arrivalDelay;
    }

    public void setArrivalDelay(Integer arrivalDelay) {
        this.arrivalDelay = arrivalDelay;
    }

    public Boolean getRealTime() {
        return realTime;
    }

    public void setRealTime(Boolean realTime) {
        this.realTime = realTime;
    }

    public Double getDistance() {
        return distance;
    }

    public void setDistance(Double distance) {
        this.distance = distance;
    }

    public Boolean getPathway() {
        return pathway;
    }

    public void setPathway(Boolean pathway) {
        this.pathway = pathway;
    }

    public String getMode() {
        return mode;
    }

    public void setMode(String mode) {
        this.mode = mode;
    }

    public String getRoute() {
        return route;
    }

    public void setRoute(String route) {
        this.route = route;
    }

    public Integer getAgencyTimeZoneOffset() {
        return agencyTimeZoneOffset;
    }

    public void setAgencyTimeZoneOffset(Integer agencyTimeZoneOffset) {
        this.agencyTimeZoneOffset = agencyTimeZoneOffset;
    }

    public Boolean getInterlineWithPreviousLeg() {
        return interlineWithPreviousLeg;
    }

    public void setInterlineWithPreviousLeg(Boolean interlineWithPreviousLeg) {
        this.interlineWithPreviousLeg = interlineWithPreviousLeg;
    }

    public TransitStop getFrom () {
        return from;
    }

    public void setFrom(TransitStop from) {
        this.from = from;
    }

    public TransitStop getTo() {
        return to;
    }

    public void setTo(TransitStop to) {
        this.to = to;
    }

    public LegGeometry getLegGeometry() {
        return legGeometry;
    }

    public void setLegGeometry(LegGeometry legGeometry) {
        this.legGeometry = legGeometry;
    }

    public Boolean getRentedBike() {
        return rentedBike;
    }

    public void setRentedBike(Boolean rentedBike) {
        this.rentedBike = rentedBike;
    }

    public Integer getDuration() {
        return duration;
    }

    public void setDuration(Integer duration) {
        this.duration = duration;
    }

    public Boolean getTransitLeg() {
        return transitLeg;
    }

    public void setTransitLeg(Boolean transitLeg) {
        this.transitLeg = transitLeg;
    }

    public List<TransitStop> getIntermediateStops() {
        return intermediateStops;
    }

    public void setIntermediateStops(List<TransitStop> intermediateStops) {
        this.intermediateStops = intermediateStops;
    }

    public List<Step> getSteps() {
        return steps;
    }

    public void setSteps(List<Step> steps) {
        this.steps = steps;
    }

    public String getAgencyName() {
        return agencyName;
    }

    public void setAgencyName(String agencyName) {
        this.agencyName = agencyName;
    }

    public String getAgencyUrl() {
        return agencyUrl;
    }

    public void setAgencyUrl(String agencyUrl) {
        this.agencyUrl = agencyUrl;
    }

    public String getRouteColor() {
        return routeColor;
    }

    public void setRouteColor(String routeColor) {
        this.routeColor = routeColor;
    }

    public Integer getRouteType() {
        return routeType;
    }

    public void setRouteType(Integer routeType) {
        this.routeType = routeType;
    }

    public String getRouteId() {
        return routeId;
    }

    public void setRouteId(String routeId) {
        this.routeId = routeId;
    }

    public String getRouteTextColor() {
        return routeTextColor;
    }

    public void setRouteTextColor(String routeTextColor) {
        this.routeTextColor = routeTextColor;
    }

    public String getHeadsign() {
        return headsign;
    }

    public void setHeadsign(String headsign) {
        this.headsign = headsign;
    }

    public String getAgencyId() {
        return agencyId;
    }

    public void setAgencyId(String agencyId) {
        this.agencyId = agencyId;
    }

    public String getTripId() {
        return tripId;
    }

    public void setTripId(String tripId) {
        this.tripId = tripId;
    }

    public String getServiceDate() {
        return serviceDate;
    }

    public void setServiceDate(String serviceDate) {
        this.serviceDate = serviceDate;
    }

    public String getRouteShortName() {
        return routeShortName;
    }

    public void setRouteShortName(String routeShortName) {
        this.routeShortName = routeShortName;
    }

    public String getRouteLongName() {
        return routeLongName;
    }

    public void setRouteLongName(String routeLongName) {
        this.routeLongName = routeLongName;
    }


    public List <TransitStop> getAllMetroStops () {

        if (this.mode.equals("SUBWAY")) {
            List<TransitStop> metroStops = new ArrayList<>();
            metroStops.add(this.from); //Add the first transit stop of this Leg
            metroStops.addAll(this.intermediateStops);//Add the intermediate transit stops of this Leg
            metroStops.add(this.to); //Add the last transit stop of this Leg
            return (metroStops);
        }

        else return null;
    }




}
