
package jimenezcarlos.android.uoc.edu.rest.model.TMBPlannerAPI;

import java.io.Serializable;
import java.util.List;
import com.google.gson.annotations.Expose;
import com.google.gson.annotations.SerializedName;

public class Plan implements Serializable {

    @SerializedName("date")
    @Expose
    private String date;
    @SerializedName("from")
    @Expose
    private Point from;
    @SerializedName("to")
    @Expose
    private Point to;
    @SerializedName("itineraries")
    @Expose
    private List<Itinerary> itineraries = null;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Plan() {
    }

    /**
     * 
     * @param date (String in format dd-mm-yyyy)
     * @param itineraries
     * @param from
     * @param to
     */
    public Plan(String date, Point from, Point to, List<Itinerary> itineraries) {
        super();
        this.date = date;
        this.from = from;
        this.to = to;
        this.itineraries = itineraries;
    }

    public String getDate() {
        return date;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public Point getFrom() {
        return from;
    }

    public void setFrom(Point from) {
        this.from = from;
    }

    public Point getTo() {
        return to;
    }

    public void setTo(Point to) {
        this.to = to;
    }

    public List<Itinerary> getItineraries() {
        return itineraries;
    }

    public void setItineraries(List<Itinerary> itineraries) {
        this.itineraries = itineraries;
    }

}
