package jimenezcarlos.android.uoc.edu.rest.model.TMBPlannerAPI;

import android.location.Location;

import com.google.android.libraries.places.api.model.Place;

import java.io.Serializable;

// This class is used to pass needed information from NewJourneyActivity to RouteSelectionActivity

public class SerializableOriginDestination implements Serializable {

    private String mOriginAddress;
    private String mDestinationAddress;
    // Coordinates will be stored in a string in format: "{lat},{lon}".
    // Using this format, we will be ready to call Planner TMB API
    private String mOriginCoordinates;
    private String mDestinationCoordinates;


    /**
     * No args constructor for use in serialization
     *
     */
    public SerializableOriginDestination() {}

    public SerializableOriginDestination(Place DestinationPlace, String OriginAddress, Location OriginLocation) {
        super();

        mOriginAddress = OriginAddress;
        mDestinationAddress = DestinationPlace.getName().concat(", ").concat (DestinationPlace.getAddress());
        mOriginCoordinates = String.valueOf(OriginLocation.getLatitude()).concat(",").concat (String.valueOf(OriginLocation.getLongitude()));
        mDestinationCoordinates = String.valueOf(DestinationPlace.getLatLng().latitude).concat(",").concat (String.valueOf(DestinationPlace.getLatLng().longitude));
    }

    public String getDestinationAddress() {
        return mDestinationAddress;
    }

    public String getDestinationCoordinates() {
        return mDestinationCoordinates;
    }

    public String getOriginAddress () {
        return mOriginAddress;

    }

    public String getOriginCoordinates () {

        return mOriginCoordinates;

    }


}
