package jimenezcarlos.android.uoc.edu.util;

import java.util.ArrayList;

import jimenezcarlos.android.uoc.edu.camina.R;
import jimenezcarlos.android.uoc.edu.rest.model.CaminaUser;

public class AvailableBadgeCollection {

    private ArrayList<Badge> mBadgeCollection = new ArrayList<>();

    public AvailableBadgeCollection () {

        super();

        mBadgeCollection.add(new Badge("time", 200*60, "200 mins caminados","Huesos de acero", R.drawable.ic_badge_01));
        mBadgeCollection.add(new Badge("distance", 25*1000, "25 kms recorridos","Zapatilla inquieta", R.drawable.ic_badge_02));
        mBadgeCollection.add(new Badge("calories", 2000, "2000 Kcal quemadas","Amante de la báscula", R.drawable.ic_badge_03));
        mBadgeCollection.add(new Badge("time", 600*60, "600 mins caminados","Controlador de tensión", R.drawable.ic_badge_04));
        mBadgeCollection.add(new Badge("distance", 100*1000, "100 kms recorridos","Corazón sano", R.drawable.ic_badge_05));
        mBadgeCollection.add(new Badge("calories", 5000, "5000 Kcal quemadas","Cinturita de avispa", R.drawable.ic_badge_06));
        mBadgeCollection.add(new Badge("time", 1500*60, "1500 mins caminados","Terror de la hipertensión", R.drawable.ic_badge_07));
        mBadgeCollection.add(new Badge("distance", 300*1000, "300 kms recorridos","Corazón de acero", R.drawable.ic_badge_08));
        mBadgeCollection.add(new Badge("calories", 15000, "15000 Kcal quemadas", "Caminante del año", R.drawable.ic_badge_09_m));
        mBadgeCollection.add(new Badge("time", 3500*60, "3500 mins caminados", "Destructor de colesterol", R.drawable.ic_badge_10));
        mBadgeCollection.add(new Badge("distance", 800*1000, "800 kms recorridos", "Amigo del Doctor", R.drawable.ic_badge_11));
        mBadgeCollection.add(new Badge("calories", 40000, "40000 Kcal quemadas", "Cuerpazo sano", R.drawable.ic_badge_12));
        mBadgeCollection.add(new Badge ("time", 10000*60, "10000 mins caminados", "Forrest Gump", R.drawable.ic_badge_13));
        mBadgeCollection.add(new Badge ("distance", 2000*1000, "2000 kms recorridos", "Aniquilador de medicamentos", R.drawable.ic_badge_14));
        mBadgeCollection.add(new Badge ("stations", 200, "200 paradas saltadas", "Saltador Olímpico", R.drawable.ic_badge_15));

    }

    //Public method
    //Given the global statistics of a user, get the corresponding badgets

    public ArrayList <Badge> getBadges (CaminaUser c) {
        ArrayList <Badge> userBadges = new ArrayList<>();

        for (Badge b:mBadgeCollection){
            switch (b.getParameter()) {
                case "time":

                    if (c.getTotalTime() >= b.getRequirement())
                    {
                        // Include this badge in user's collection
                        userBadges.add (b);
                    }

                    else {
                        // Include a new generated badge without disclosing its name and picture
                        userBadges.add (new Badge (b.getParameter(), b.getRequirement(), b.getRequirementLabel(), "???\n???", R.drawable.ic_badge_unknown));
                    }

                    break;
                case "distance":

                    if (c.getTotalDistance() >= b.getRequirement())
                    {
                        // Include this badge in user's collection
                        userBadges.add (b);
                    }

                    else {
                        // Include a new generated badge without disclosing its name and picture
                        userBadges.add (new Badge (b.getParameter(), b.getRequirement(), b.getRequirementLabel(), "???\n???", R.drawable.ic_badge_unknown));
                    }

                    break;

                case "calories":

                    if (c.getTotalCalories() >= b.getRequirement())
                    {
                        // Include this badge in user's collection
                        userBadges.add (b);
                    }

                    else {
                        // Include a new generated badge without disclosing its name and picture
                        userBadges.add (new Badge (b.getParameter(), b.getRequirement(), b.getRequirementLabel(), "???\n???", R.drawable.ic_badge_unknown));
                    }

                    break;

                case "stations":

                    if (c.getTotalSkippedStations() >= b.getRequirement())
                    {
                        // Include this badge in user's collection
                        userBadges.add (b);
                    }

                    else {
                        // Include a new generated badge without disclosing its name and picture
                        userBadges.add (new Badge (b.getParameter(), b.getRequirement(), b.getRequirementLabel(), "???\n???", R.drawable.ic_badge_unknown));
                    }

                    break;

                default:

                    break;
            }

        }

        return userBadges;
    }


}
