package jimenezcarlos.android.uoc.edu.util;
import java.util.Comparator;

import org.apache.commons.lang3.builder.CompareToBuilder;

import jimenezcarlos.android.uoc.edu.rest.model.TMBPlannerAPI.Itinerary;

 /**
 * This comparator sorts a list of Itinerary by walktime, walkdistance into descending order,
 * and then total duration into ascending order.
 **/

public class ItineraryComparator implements Comparator<Itinerary> {

    @Override
    public int compare(Itinerary o1, Itinerary o2) {
        return new CompareToBuilder()
                .append(o2.getWalkTime(), o1.getWalkTime())
                .append(o2.getWalkDistance(), o1.getWalkDistance())
                .append(o1.getDuration(), o2.getDuration()).toComparison();
    }

}



